#!/usr/bin/env python
# -=- encoding: utf-8 -=-

import pygst
pygst.require("0.10")
import gst
import gobject

class AudioClient():
    def __init__(self,mhost="224.168.2.9",mport=1602):
        #Thread.__init__(self)
        self.mainloop = gobject.MainLoop()
        self.multicast_host = mhost
        self.multicast_port = mport
        self.pipeline = gst.Pipeline('client')
        bus = self.pipeline.get_bus()
        udpsrc = gst.element_factory_make("udpsrc")
        udpsrc.set_property("multicast-group",self.multicast_host)
        udpsrc.set_property("port",self.multicast_port)
        udpsrc.set_property('auto-multicast', "true")
        caps = gst.Caps("application/x-rtp,media=(string)audio, clock-rate=(int)44100, width=16, height=16, encoding-name=(string)L16, encoding-params=(string)1, channels=(int)1, channel-positions=(int)1, payload=(int)96")
        filter = gst.element_factory_make("capsfilter", "filter")
        filter.set_property("caps", caps)
        rtpL16depay     = gst.element_factory_make("rtpL16depay")
        audioconvert = gst.element_factory_make("audioconvert")
        alsasink = gst.element_factory_make("alsasink")
        alsasink.set_property('sync',"false")

        self.pipeline.add(udpsrc, filter,rtpL16depay ,audioconvert,alsasink)

        gst.element_link_many(udpsrc, filter,rtpL16depay ,audioconvert,alsasink)
        bus =self.pipeline.get_bus()
        bus.add_signal_watch()
        bus.enable_sync_message_emission()

    def go(self):
        print "AudioClient escuchando en (%s : %i)"%(self.multicast_host,self.multicast_port)
        self.pipeline.set_state(gst.STATE_PLAYING)

