#!/usr/bin/env python
# -=- encoding: utf-8 -=-

import pygst
pygst.require("0.10")
import gst
import gobject

class AudioServer():
    def __init__(self,mhost="224.168.2.9",mport=1602):
        #Thread.__init__(self)
        self.mainloop = gobject.MainLoop()

        self.multicast_host = mhost
        self.multicast_port = mport
        self.pipeline = gst.Pipeline('server')
        bus = self.pipeline.get_bus()
        source = gst.element_factory_make("alsasrc")
        source.set_property("device",'hw:0,0')
        caps = gst.Caps("audio/x-raw-int,channels=1,depth=16,width=16,rate=44100")
        filter = gst.element_factory_make("capsfilter", "filter")
        filter.set_property("caps", caps)
        q = gst.element_factory_make("queue", "q1")
        audioconvert = gst.element_factory_make("audioconvert")
        rtpL16pay     = gst.element_factory_make("rtpL16pay")
        udpsink_rtpout = gst.element_factory_make("udpsink")
        udpsink_rtpout.set_property('host', self.multicast_host)
        udpsink_rtpout.set_property('auto-multicast', "true")
        udpsink_rtpout.set_property('port', self.multicast_port)

        self.pipeline.add(source, audioconvert,filter,rtpL16pay ,udpsink_rtpout)

        gst.element_link_many(source, audioconvert,filter,rtpL16pay ,udpsink_rtpout)
        bus =self.pipeline.get_bus()
        bus.add_signal_watch()
        bus.enable_sync_message_emission()
    def go(self):
        print "AudioServer transmitiendo a (%s : %i)"%(self.multicast_host,self.multicast_port)
        self.pipeline.set_state(gst.STATE_PLAYING)

