import socket
from Listeners import *
import struct

class ServerHandler():

    def __init__(self,mcast_addr,mcastPort):
        self.mcastAddr = mcast_addr
        self.mcastPort = mcastPort
        self.sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)
        self.sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.sock.setsockopt(socket.SOL_IP, socket.IP_MULTICAST_TTL, 5)

        try:
            self.sock.bind(('',self.mcastPort))
            group = socket.inet_aton(self.mcastAddr)
            mreq = struct.pack('4sL', group, socket.INADDR_ANY)
            self.sock.setsockopt(socket.IPPROTO_IP, socket.IP_ADD_MEMBERSHIP, mreq)
        except ValueError,e:
            print e
        self.sock2 = socket.socket(socket.AF_INET, socket.SOCK_DGRAM, socket.IPPROTO_UDP)
        self.sock2.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.sock2.setsockopt(socket.SOL_IP, socket.IP_MULTICAST_TTL, 5)

        try:
            self.sock2.bind(('',self.mcastPort+1))
            self.sock2.setsockopt(socket.IPPROTO_IP, socket.IP_ADD_MEMBERSHIP, mreq)
        except ValueError,e:
            print e


    def sendto_multicast(self,data):
        self.sock.sendto(data, (self.mcastAddr,self.mcastPort))

    def start_text_listener(self,chatarea):
        self.chat_area = chatarea
        self.text_listener = TextListener(self.sock,self.chat_area)
        self.text_listener.start()
        print "TextListener escuchando en (%s : %i)"%(self.mcastAddr,self.mcastPort)

    def start_image_listener(self,imgarea):
        self.img_area = imgarea
        self.img_listener = ImgListener(self.sock2,self.img_area)
        self.img_listener.start()
        print "ImageListener escuchando en (%s : %i)"%(self.mcastAddr,self.mcastPort+1)

    def send_photo(self,filename):
        f = open(filename,'rb')
        self.sock2.sendto("STARTIMG", (self.mcastAddr,self.mcastPort+1))
        while 1:
            blk=f.read(2048)
            if not blk:break
            self.sock2.sendto(blk, (self.mcastAddr,self.mcastPort+1))
        self.sock2.sendto("ENDIMG", (self.mcastAddr,self.mcastPort+1))
        f.close()
